
 breed [compradores comprador]
 breed [vendedores vendedor]
 undirected-link-breed [conexoes conexao]
 undirected-link-breed [conexoes-a conexao-a]
 undirected-link-breed [ligacoes-v ligacao-v ]
 
 globals [
;   custo_de_desistir ;10
;   custo_de_acesso ;1
;   custo_de_busca ;1
   reducao_fidelidade ;1
   pc
   pv
   taxa_renovacao
   transacao
  
 ]
 
 
 
 compradores-own[
   remuneracao
   caixa
   preco_c
   pec ;payoff estrategia do comprador
   limiar
   obj
   felicidade
  
 ]
 
 vendedores-own [
   caixa
   caixa_inicial
   preco_v
   preco_v_t-1
   mkt_share
   posicao_preco
   qtd_v
   qtd_v_t-1
;   qtd
   alfa
   beta
   gama
   delta
   condicao
   estrategia
   step1
   step2
   zeta1
   zeta2
   pos
   custo_de_operacao
 ]
 
 
 conexoes-own [
   fidelidade
  
 ]
 
 conexoes-a-own [
   fidelidade
 ]
 


   
to setup
    clear-all
 
 ;  set custo_de_desistir 100
 ;  set custo_de_acesso 10
 ;  set custo_de_busca 50
   set transacao 0
 
 
    ask patches [set pcolor black]
    
    ask n-of numero_vendedores patches with [not any? turtles-here]
     [sprout-vendedores 1 [
         set color yellow
         set shape "flag" 
         set preco_v random 31 + 10
         set caixa random-normal 250000 25000
         set qtd_v 1
         set estrategia [10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80]
         set alfa random (41) / 100 ;set alfa .2
         set beta random (41) / 100 ;set beta .2
         set gama random (61) / 100 ;set gama .3
         set delta random (41) / 100 ;set delta .2
         set step1 random (21) / 100 ;set step1 .11
         set step2 random (11) / 100 ;set step2 .03
         set zeta1 random (11) / 100 ;set zeta1 .05
         set zeta2 random (41) / 100 ;set zeta2 .2
         set pos 0
         set custo_de_operacao random-normal custo_operacao_m_vendedor (variacao_custo_operacao * custo_operacao_m_vendedor)

         ]
     ]
  
    ask vendedores [
      create-ligacoes-v-with n-of 2 (other vendedores) [
      set color lime ]]
    
    ask n-of numero_compradores patches with [not any? turtles-here]
    [sprout-compradores 1 [
        set color violet
        set shape "dot"
        set remuneracao random-normal renda_media_comprador (variacao_renda_media_comprador * renda_media_comprador)
        set caixa random-normal 600 60
        set preco_c 1 + random (remuneracao * 2)
        set pec [1667 1667 1667 1667 1666 1666] 
        set limiar (random-normal 100 21) / 100
        set obj true
        set felicidade 0
        ]
    ]
    

    ask compradores [ 
      create-conexoes-with n-of conexoes_com_vendedores vendedores ]
    
    ask conexoes [
      set fidelidade 1

      ]
    
    ask links [hide-link]
    
;    set-current-directory "c:\\dados"
;    file-open "myfile-1.txt"
;    file-write "conexoes"
;    file-write "compradores"
;    file-write "vendedores"
;    file-write "estrategia-1"
;    file-write "estrategia-2"
;    file-write "estrategia-3"
;    file-write "estrategia-4"
;    file-write "estrategia-5"
;    file-write "estrategia-6"
;    file-write "preco_C"
;    file-write "preco_V"
;    file-write "caixa_C"
;    file-write "caixa_V"
;    file-write "tx_renovacao"
;    file-write "comprou"
;    file-write "N_comprou"
;    file-write "felicidade"
;    file-write "qtd_v"
;    file-print " "
        
    
    reset-ticks
end
    
  

to go
  

  atualiza_vendedores
  forma_preco_compradores
  morre
 ; file-write count conexoes
 ; file-write count compradores
 ; file-write count vendedores
 ; file-write sum [item 0 pec] of compradores
 ; file-write sum [item 1 pec] of compradores
 ; file-write sum [item 2 pec] of compradores
 ; file-write sum [item 3 pec] of compradores
 ; file-write sum [item 4 pec] of compradores
 ; file-write sum [item 5 pec] of compradores
 ; file-write sum [preco_c] of compradores
 ; file-write sum [preco_v] of vendedores
 ; file-write sum [caixa] of compradores
 ; file-write sum [caixa] of vendedores
 ; file-write taxa_renovacao
 ; file-write count compradores with [obj = true]
 ; file-write count compradores with [obj = false]
 ; file-write sum [felicidade] of compradores
 ; file-write sum [qtd_v] of vendedores 
 ; file-print " "
  
  tick
  if ticks > 10000 [file-close stop]

end

to atualiza_vendedores

  ask vendedores [
    
    
    if caixa = 0 [set caixa .1]
    if preco_v = 0 [set preco_v .1]
    if qtd_v = 0 [set qtd_v .1]
    
    
    if caixa_inicial = 0 [set caixa_inicial caixa]
    if preco_v_t-1 = 0 [set preco_v_t-1 preco_v]
    if qtd_v_t-1 = 0 [set qtd_v_t-1 qtd_v]
    
    
    let ganho (caixa - caixa_inicial) / caixa_inicial
    let temp item condicao estrategia
    let temp2 item (condicao + 1) estrategia
    if (ganho < zeta1 and pos = 1) [ set estrategia replace-item condicao estrategia (temp * .9)]
    if (ganho > zeta2 and pos = 2) [ set estrategia replace-item condicao estrategia (temp2 * .9)]
    if (ganho < zeta1 and pos = 2) [ set estrategia replace-item condicao estrategia (temp2 * 1.1)]
    if (ganho > zeta2 and pos = 1) [ set estrategia replace-item condicao estrategia (temp * 1.1)]
    
    
    let a 0
    let b 0
    let c 0
    let d 0
    let var_preco (preco_v - preco_v_t-1) / preco_v_t-1
    let var_qtd (qtd_v - qtd_v_t-1) / qtd_v_t-1
    set mkt_share (count compradores - qtd_v) / (count compradores)
    let p_concorrente (sum [preco_v] of ligacao-v-neighbors / (1 + count ligacao-v-neighbors))
    set posicao_preco (preco_v - p_concorrente) / (1 + p_concorrente)
  
    if var_preco < (- alfa) [ set a 1 ] ;houve queda no preco de venda de alfa por cento
    if var_preco > alfa [ set a 2 ] ;houve aumento no preco de venda de alfa por cento
    if var_qtd < (- beta) [set b 1] ;houve queda na quantidade vendida de beta por cento
    if var_qtd > beta [set b 2] ;houve aumento na quantidade vendida de beta por cento
    if mkt_share < gama [set c 1] ;market share inferior a gama por cento
    if mkt_share > (1 - gama) [set c 2] ;market share superior a gama por cento
    if posicao_preco < (- delta) [set d 1] ;preco abaixo do concorrente em delta por cento
    if posicao_preco > delta [set d 2] ;preco acima do concorrente em delta por cento
    
    set condicao (a + b * 3 + c * 9 + d * 27) * 2
    set pos 0
         
    let escolha random 101
    if escolha <= item condicao estrategia [ set preco_v preco_v * (1 - step2) set pos 1 ]
    if escolha >= item (condicao + 1) estrategia [ set preco_v preco_v * (1 + step1) set pos 2 ]
    

   ; if caixa < renda_media_comprador [set preco_v renda_media_comprador * .5]
   if preco_v > 1E99 [set preco_v 1E99]
    set qtd_v 0
    set caixa_inicial caixa
    set preco_v_t-1 preco_v
    set qtd_v_t-1 qtd_v
    set caixa caixa - custo_de_operacao
;;    show custo_de_operacao
  ]
end     


to forma_preco_compradores
  
  ask compradores [

    let j []
    let i 0
    foreach pec [
      set i i + ?
      set j lput i j
    ]
    set caixa caixa + remuneracao
    set obj false
    set shape "dot"
    primeira_escolha
    if obj = true [       set shape "star"]
    if obj = false [
      set i random (10000) + 1 
      if i <= item 0 j [estrategia_1]
      if (i <= item 1 j) and (i > item 0 j) [estrategia_2]
      if (i <= item 2 j) and (i > item 1 j) [estrategia_3]
      if (i <= item 3 j) and (i > item 2 j) [estrategia_4]
      if (i <= item 4 j) and (i > item 3 j) [estrategia_5]
      if (i <= item 5 j) and (i > item 4 j) [estrategia_6]
    ]  
  
  clear_vendedores
  if caixa < 0 [set caixa 0 set felicidade felicidade - 50]
  ajusta_pec
  ]



  ask conexoes-a [set breed conexoes]

  
end 

    
to primeira_escolha
   let a who
   set pc preco_c
   carefully [
     ask one-of my-links with-max [fidelidade] [    
       set breed conexoes-a
       ask other-end [ 
         let b who 
         negociar a b
        ]
     ]
   ] [set shape "bug"] 
end

 
to negociar [a b]
   set pv preco_v
   ask comprador a [set pc preco_c ]
   

   ifelse pv <= pc [
     set transacao transacao + 1
     ask comprador a [

       set caixa caixa - pv
       set obj true
       set preco_c pv * 1
       set felicidade felicidade + 1

       ]
     
       set caixa caixa + pv
       set qtd_v qtd_v + 1
       ask link-with comprador a [ set fidelidade fidelidade + 1 ]    
   ]

       [
       ask link-with comprador a [ set fidelidade fidelidade - 1 ]
      
       ]
   
   
 end 
    

 to paga_mais_caro
   
   let a who
   ask comprador a [     
       set pc preco_c * (1 + limiar)
       carefully [
         ask one-of conexao-a-neighbors with-min[preco_v] [
           let b who
           negociar a b
         ]
       ] [set shape"bug"]
   ]
    
   
  end   
 
 to acessa_vendedores
   set pc preco_c
   let a who
   if any? conexao-neighbors with [preco_v <= pc] [
     ask one-of conexao-neighbors with-min [preco_v] [ 
       let b who
       negociar a b

      ]
     ask my-conexoes [set breed conexoes-a]       
   ]

 end  
 
 to busca_vendedores
   let a who
    if count my-links < count vendedores [
    ask one-of vendedores with [not (link-neighbor? comprador a)] [
      let b who
      create-conexao-a-with myself [
        set fidelidade 1
        hide-link]
      negociar a b
      ]
    ]
 end
 
 to clear_vendedores
   
   let cont_1 count my-links with [fidelidade < -5]
   if (cont_1 > 1) [ ask one-of my-links with-min [fidelidade] [die]]

 end    

to estrategia_1
   ;; tenta pagar mais caro --> tenta acessar a rede --> busca vendedores
   set color red
   if obj = false [ 
        paga_mais_caro
        if obj = false [        
           acessa_vendedores 
           set caixa caixa - custo_de_acesso * count(my-conexoes) / 2
           if obj = false [
             busca_vendedores
             set caixa caixa - custo_de_busca 
     ]]]

     ifelse  obj = false [
       set caixa caixa - custo_de_desistir
       set preco_c preco_c + custo_de_desistir / 2
       set felicidade felicidade - 20
       atualiza_pec 1 false ]
       [atualiza_pec 1 true]

 end

to estrategia_2
   ;; tenta pagar mais caro -->  busca vendedores --> acessa a rede
   set color lime
   if obj = false [ 
        paga_mais_caro
        if obj = false [ 
           busca_vendedores 
           set caixa caixa - custo_de_busca
           if obj = false [ 
             acessa_vendedores 
             set caixa caixa - custo_de_acesso * count(my-conexoes) / 2
     ]]]

     ifelse  obj = false [
       set caixa caixa - custo_de_desistir
       set preco_c preco_c + custo_de_desistir / 2
       set felicidade felicidade - 20
       atualiza_pec 2 false ]
       [atualiza_pec 2 true]
 end

to estrategia_3
   ;; tenta acessar a rede --> pagar mais caro -->  busca vendedores
   set color cyan
   if obj = false [ 
        acessa_vendedores
        set caixa caixa - custo_de_acesso * count(my-conexoes) / 2
        if obj = false [ 
           paga_mais_caro
           set caixa caixa - custo_de_acesso
           if obj = false [ 
             busca_vendedores
             set caixa caixa - custo_de_busca
      ]]]

     ifelse  obj = false [
       set caixa caixa - custo_de_desistir
       set preco_c preco_c + custo_de_desistir / 2
       set felicidade felicidade - 20
       atualiza_pec 3 false ]
       [atualiza_pec 3 true]
 end

to estrategia_4
   ;; tenta acessar a rede --> busca vendedores --> paga_mais_caro
   set color gray
   if obj = false [ 
        acessa_vendedores
        set caixa caixa - custo_de_acesso * count(my-conexoes) / 2
        if obj = false [ 
           busca_vendedores
           set caixa caixa - custo_de_busca
           if obj = false [ 
             paga_mais_caro
             set caixa caixa - custo_de_acesso
     ]]]

     ifelse  obj = false [
       set caixa caixa - custo_de_desistir
       set preco_c preco_c + custo_de_desistir / 2
       set felicidade felicidade - 20
       atualiza_pec 4 false ]
       [atualiza_pec 4 true]
 end

to estrategia_5
   ;; tenta buscar vendedores --> paga_mais_caro --> acessar a rede
   set color blue
   if obj = false [ 
        busca_vendedores
        set caixa caixa - custo_de_busca
        if obj = false [ 
            paga_mais_caro
            set caixa caixa - custo_de_acesso
            if obj = false [ 
              acessa_vendedores
              set caixa caixa - custo_de_acesso * count(my-conexoes) / 2
     ]]]

     ifelse  obj = false [
       set caixa caixa - custo_de_desistir
       set preco_c preco_c + custo_de_desistir / 2
       set felicidade felicidade - 20
       atualiza_pec 5 false ]
       [atualiza_pec 5 true]
 end

to estrategia_6
   ;; tenta buscar vendedores --> acessar a rede --> pagar mais caro
   set color pink
   if obj = false [ 
         busca_vendedores
         set caixa caixa - custo_de_busca
         if obj = false [
            acessa_vendedores
            set caixa caixa - custo_de_acesso * count (my-conexoes) / 2
            if obj = false [ 
              paga_mais_caro
              set caixa caixa - custo_de_acesso
       ]]]
     set felicidade felicidade + 1
     ifelse  obj = false [
       set caixa caixa - custo_de_desistir
       set preco_c preco_c + custo_de_desistir / 2
       set felicidade felicidade - 20
       atualiza_pec 6 false ]
       [atualiza_pec 6 true]
 end


to morre
  let a 0
  set taxa_renovacao count compradores with [felicidade < -100]

  ask compradores with [felicidade < felicidade_limite] [
    
     if renova_comprador [
     ask one-of patches with [not any? turtles-here] [
     let i random (101) / 100
     if i <= 1 [  
     sprout-compradores 1 [
        set color white
        set shape "dot"
        set remuneracao random-normal renda_media_comprador (variacao_renda_media_comprador * renda_media_comprador)
        set caixa random-normal 600 60
        set preco_c 1 + random (remuneracao * 2)
        set pec [1667 1667 1667 1667 1666 1666] 
        set limiar (random-normal 100 21) / 100
        set obj true
        set felicidade 0
        ifelse count vendedores < conexoes_com_vendedores [set a count vendedores][set a conexoes_com_vendedores]
        create-conexoes-with n-of a vendedores [hide-link]
        ]]]]
      if morte_comprador [ die]

  ]

  ask vendedores with [caixa < .1] [

     if renova_vendedor [
     ask one-of patches with [not any? turtles-here] [
     let i random (101) / 100
     if i <= 1 [  
       sprout-vendedores 1 [
         set color yellow
         set shape "flag" 
         set preco_v random 31 + 10
         set caixa random-normal 3000 100
         set qtd_v 1
         set estrategia [10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80 10 80]
         set alfa random (41) / 100 ;set alfa .2
         set beta random (41) / 100 ;set beta .2
         set gama random (61) / 100 ;set gama .3
         set delta random (41) / 100 ;set delta .2
         set step1 random (21) / 100 ;set step1 .11
         set step2 random (11) / 100 ;set step2 .03
         set zeta1 random (11) / 100 ;set zeta1 .05
         set zeta2 random (41) / 100 ;set zeta2 .2
         set pos 0
         create-ligacoes-v-with n-of 2 (other vendedores) [
      set color lime
      hide-link ]
       ]]]]
     if morte_vendedor [ die]
  ]
end

to atualiza_pec[est f]

  let a 0
  let b 0
  ifelse f [ set a 1750 set b -350][ set a -1750 set b 350]
   set pec replace-item 0 pec (item 0 pec + b)
   set pec replace-item 1 pec (item 1 pec + b)
   set pec replace-item 2 pec (item 2 pec + b) 
   set pec replace-item 3 pec (item 3 pec + b) 
   set pec replace-item 4 pec (item 4 pec + b) 
   set pec replace-item 5 pec (item 5 pec + b)
   set pec replace-item (est - 1) pec (item (est - 1) pec - b + a)

end   
  
to ajusta_pec
  let a 0
  let i 5
  while [i >= 0] [
   if item i pec < 0 [ 
    set a (item i pec) / -5
    set pec replace-item 0 pec (item 0 pec + a)  
    set pec replace-item 1 pec (item 1 pec + a)
    set pec replace-item 2 pec (item 2 pec + a)  
    set pec replace-item 3 pec (item 3 pec + a)
    set pec replace-item 4 pec (item 4 pec + a)        
    set pec replace-item 5 pec (item 5 pec + a)    
    set pec replace-item i pec 0
  ]
   set i i - 1
  ] 
end   
   
   
    
@#$#@#$#@
GRAPHICS-WINDOW
915
10
1341
483
15
16
13.42
1
10
1
1
1
0
1
1
1
-15
15
-16
16
1
1
1
ticks
30.0

BUTTON
6
10
69
43
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
5
48
177
81
numero_vendedores
numero_vendedores
0
600
300
1
1
NIL
HORIZONTAL

SLIDER
180
48
353
81
numero_compradores
numero_compradores
0
600
600
1
1
NIL
HORIZONTAL

BUTTON
74
10
137
43
Go
Go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
0

SLIDER
356
48
546
81
conexoes_com_vendedores
conexoes_com_vendedores
1
numero_vendedores
15
1
1
NIL
HORIZONTAL

BUTTON
143
10
222
43
Go Once
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
1
244
456
448
Conexoes Comprador - Vendedor
tempo
# médio de conexões
0.0
500.0
0.0
50.0
true
true
"" ""
PENS
"c/c" 1.0 0 -955883 true "" "plot (count conexoes / count compradores)"

PLOT
5
86
454
238
Estratégias Comprador
NIL
NIL
0.0
500.0
0.0
0.5
true
true
"" ""
PENS
"estrategia 1" 1.0 0 -2674135 true "" "plot sum [item 0 pec] of compradores / numero_compradores / 10000"
"estrategia 2" 1.0 0 -13840069 true "" "plot sum [item 1 pec] of compradores / numero_compradores / 10000"
"estrategia 3" 1.0 0 -11221820 true "" "plot sum [item 2 pec] of compradores / numero_compradores / 10000"
"estrategia 4" 1.0 0 -7500403 true "" "plot sum [item 3 pec] of compradores / numero_compradores / 10000"
"estrategia 5" 1.0 0 -13345367 true "" "plot sum [item 4 pec] of compradores / numero_compradores / 10000"
"estrategia 6" 1.0 0 -2064490 true "" "plot sum [item 5 pec] of compradores / numero_compradores / 10000"

PLOT
670
596
890
749
Preco de venda e compra
NIL
NIL
0.0
100.0
0.0
10.0
true
true
"" ""
PENS
"comprador" 1.0 0 -16777216 true "" ";plot sum ([preco_c] of compradores) / count compradores"
"vendedor" 1.0 0 -13840069 true "" ";plot sum ([preco_v] of vendedores) / ( 1 + sum [qtd_v] of vendedores)"

PLOT
482
443
682
593
caixa médio comprador
NIL
NIL
0.0
500.0
0.0
10.0
true
false
"" ""
PENS
"caixa" 1.0 0 -16777216 true "" "plot sum [caixa] of compradores / count compradores"

PLOT
480
289
680
439
preco unitario
NIL
NIL
0.0
200.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot sum [preco_v] of vendedores / count vendedores"
"pen-1" 1.0 0 -7500403 true "" "plot sum [qtd_v] of vendedores / count vendedores"

PLOT
5
452
359
630
Oferta e demanda
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"demanda" 1.0 0 -16777216 true "" "plotxy (count compradores) (sum [preco_c] of compradores / count compradores)"
"oferta" 1.0 0 -2674135 true "" "plotxy (1 + sum [qtd_v] of vendedores) (sum [preco_v] of vendedores / ( 1 + sum [qtd_v] of vendedores))"

PLOT
689
290
889
440
Taxa de renovacao
NIL
NIL
0.0
10.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot taxa_renovacao / count compradores"

PLOT
921
488
1121
638
Conseguiu comprar
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"true" 1.0 0 -16777216 true "" "plot count compradores with [obj = true]"
"false" 1.0 0 -955883 true "" "plot count compradores with [obj = false]"

PLOT
690
445
890
595
Caixa médio vendedor
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot sum [caixa] of vendedores / count vendedores"

SWITCH
228
10
382
43
morte_comprador
morte_comprador
0
1
-1000

SWITCH
386
10
547
43
renova_comprador
renova_comprador
1
1
-1000

SWITCH
550
10
698
43
morte_vendedor
morte_vendedor
0
1
-1000

SWITCH
701
10
856
43
renova_vendedor
renova_vendedor
1
1
-1000

PLOT
1125
488
1325
638
Felicidade média
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot sum [felicidade] of compradores / count compradores"

SLIDER
712
121
884
154
Custo_de_desistir
Custo_de_desistir
1
100
100
1
1
NIL
HORIZONTAL

SLIDER
711
160
883
193
Custo_de_acesso
Custo_de_acesso
1
100
10
1
1
NIL
HORIZONTAL

SLIDER
711
197
883
230
Custo_de_busca
Custo_de_busca
1
100
50
1
1
NIL
HORIZONTAL

SLIDER
505
246
677
279
felicidade_limite
felicidade_limite
-100
0
-100
-1
1
NIL
HORIZONTAL

SLIDER
552
48
729
81
Renda_media_comprador
Renda_media_comprador
1
10000
100
1
1
NIL
HORIZONTAL

SLIDER
551
83
729
116
custo_operacao_m_vendedor
custo_operacao_m_vendedor
1
10000
100
1
1
NIL
HORIZONTAL

SLIDER
733
48
908
81
variacao_renda_media_comprador
variacao_renda_media_comprador
.1
1
0.3
.1
1
NIL
HORIZONTAL

PLOT
385
514
585
664
Caixa Total
Tempo
Caixa
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot sum [caixa] of compradores + sum [caixa] of vendedores"

SLIDER
733
84
909
117
variacao_custo_operacao
variacao_custo_operacao
.1
1
0.3
.1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

ghost
false
0
Polygon -7500403 true true 30 165 13 164 -2 149 0 135 -2 119 0 105 15 75 30 75 58 104 43 119 43 134 58 134 73 134 88 104 73 44 78 14 103 -1 193 -1 223 29 208 89 208 119 238 134 253 119 240 105 238 89 240 75 255 60 270 60 283 74 300 90 298 104 298 119 300 135 285 135 285 150 268 164 238 179 208 164 208 194 238 209 253 224 268 239 268 269 238 299 178 299 148 284 103 269 58 284 43 299 58 269 103 254 148 254 193 254 163 239 118 209 88 179 73 179 58 164
Line -16777216 false 189 253 215 253
Circle -16777216 true false 102 30 30
Polygon -16777216 true false 165 105 135 105 120 120 105 105 135 75 165 75 195 105 180 120
Circle -16777216 true false 160 30 30

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
